window.Gleam.initSearch([{"doc":"gleam_crypto","title":"gleam_crypto","content":"# crypto\n\n&lt;a href=&quot;https://github.com/gleam-experiments/crypto/releases&quot;&gt;&lt;img src=&quot;https://img.shields.io/github/release/gleam-experiments/crypto&quot; alt=&quot;GitHub release&quot;&gt;&lt;/a&gt;\n&lt;a href=&quot;https://discord.gg/Fm8Pwmy&quot;&gt;&lt;img src=&quot;https://img.shields.io/discord/768594524158427167?color=blue&quot; alt=&quot;Discord chat&quot;&gt;&lt;/a&gt;\n![CI](https://github.com/gleam-experiments/crypto/workflows/test/badge.svg?branch=main)\n\nA Gleam cryptography library supporting Erlang and JavaScript.\n\n## Installation\n\n```\ngleam add gleam_crypto\n```\n","url":"index.html"},{"doc":"gleam/crypto","title":"HashAlgorithm","content":"pub type HashAlgorithm {\n  Sha224\n  Sha256\n  Sha384\n  Sha512\n  Md5\n}\n\nSha224\n\n\nSha256\n\n\nSha384\n\n\nSha512\n\n\nMd5\n The MD5 hash algorithm is considered weak and should not be used for\n security purposes. It may still be useful for non-security purposes or for\n compatibility with existing systems.\n\nSynonyms:\ngleam/crypto.HashAlgorithm\ngleam/crypto HashAlgorithm","url":"gleam/crypto.html#HashAlgorithm"},{"doc":"gleam/crypto","title":"hash","content":"pub fn hash(a: HashAlgorithm, b: BitArray) -&gt; BitArray\n Computes a digest of the input bit string.\nSynonyms:\ngleam/crypto.hash\ngleam/crypto hash","url":"gleam/crypto.html#hash"},{"doc":"gleam/crypto","title":"hmac","content":"pub fn hmac(\n  data: BitArray,\n  algorithm: HashAlgorithm,\n  key: BitArray,\n) -&gt; BitArray\n Calculates the HMAC (hash-based message authentication code) for a bit\n string.\n\n Based on the Erlang [`crypto:mac`](https://www.erlang.org/doc/man/crypto.html#mac-4)\n function, or the [`node:crypto.createHmac`](https://nodejs.org/api/crypto.html#cryptocreatehmacalgorithm-key-options)\n function on JavaScript.\n\nSynonyms:\ngleam/crypto.hmac\ngleam/crypto hmac","url":"gleam/crypto.html#hmac"},{"doc":"gleam/crypto","title":"secure_compare","content":"pub fn secure_compare(left: BitArray, right: BitArray) -&gt; Bool\n Compares the two binaries in constant-time to avoid timing attacks.\n\n For more details see: http://codahale.com/a-lesson-in-timing-attacks/\n\nSynonyms:\ngleam/crypto.secure_compare\ngleam/crypto secure_compare","url":"gleam/crypto.html#secure_compare"},{"doc":"gleam/crypto","title":"sign_message","content":"pub fn sign_message(\n  message: BitArray,\n  secret: BitArray,\n  digest_type: HashAlgorithm,\n) -&gt; String\n Sign a message which can later be verified using the `verify_signed_message`\n function to detect if the message has been tampered with.\n\n A web application could use this verifier to sign HTTP cookies. The data can\n be read by the user, but cannot be tampered with.\n\nSynonyms:\ngleam/crypto.sign_message\ngleam/crypto sign_message","url":"gleam/crypto.html#sign_message"},{"doc":"gleam/crypto","title":"strong_random_bytes","content":"pub fn strong_random_bytes(a: Int) -&gt; BitArray\n Generates a specified number of bytes randomly uniform 0..255, and returns\n the result in a binary.\n\n On Erlang this uses a cryptographically secure prng seeded and periodically\n mixed with / operating system provided entropy. By default this is the\n RAND_bytes method from OpenSSL.\n &lt;https://erlang.org/doc/man/crypto.html#strong_rand_bytes-1&gt;\n\n On JavaScript the WebCrypto API is used.\n\nSynonyms:\ngleam/crypto.strong_random_bytes\ngleam/crypto strong_random_bytes","url":"gleam/crypto.html#strong_random_bytes"},{"doc":"gleam/crypto","title":"verify_signed_message","content":"pub fn verify_signed_message(\n  message: String,\n  secret: BitArray,\n) -&gt; Result(BitArray, Nil)\n Verify a message created by the `sign_message` function.\n\nSynonyms:\ngleam/crypto.verify_signed_message\ngleam/crypto verify_signed_message","url":"gleam/crypto.html#verify_signed_message"},{"doc":"gleam/crypto","title":"gleam/crypto","content":" Set of cryptographic functions.","url":"gleam/crypto.html"}]);